public class PriorityProcess extends Process implements Runnable
{
	private static PriorityProcess first;	//nchster bzw. aktueller Prozess
	private PriorityProcess next;	//Verkettung zum nchsten Prozess in der Liste
	private int prio;				//Prozess-Prioritt (1=hchste)

	public PriorityProcess(int prio) {
		super();
		this.prio = prio;
		this.init();
	}

	public static PriorityProcess getFirst() {
		return first;
	}

	public void printInfo() {	//Prozess-Informationen ausgeben
		System.out.println("PID: " + pid + ", Prio: " + prio + ", Suspended: " + isSuspended());
	}

	private void init() {	//neuen Prozess einreihen
		if(first == null) {
			first = this;
		}
		else if(first.prio > this.prio) {
			this.next = first;
			first = this;
		}
		else {
			PriorityProcess q = first;
			while(q.next != null && q.next.prio < this.prio) {
				q = q.next;
			}
			this.next = q.next;
			q.next = this;
		}
		setArriveTime();
	}

	public void removeProcess() {	//fertigen Prozess entfernen
		setDepartTime();
		int temp = this.pid;
		if(first != null) {
			if(first == this) {
				first = first.next;
			}
			else {
				PriorityProcess q = first;
				while(q.next != null && q.next != this) {
					q = q.next;
				}
				if(q.next != null) {
					q.next = q.next.next;
				}
			}
		}
		System.out.println("Process removed. PID: " + temp + ". Entire time of operation: " + opTime() + " ms.");
	}
}