public class PriorityScheduler extends Scheduler
{
  private PriorityProcess current;

  public PriorityScheduler() {
    super();	//Aufruf: Konstruktor der Oberklasse
    System.out.println("Scheduling-Strategy: Priority-Scheduling");
  }

  public void run() {	//Scheduler luft als stndiger Thread
    while(true) {	//in einer Endlosschleife
      try {
        if(current == null) { //kein Prozess aktiv
          current = PriorityProcess.getFirst();
          //zu aktivierender Prozess = erster in Liste
          System.out.print("Scheduler decided: Start with first process in queue: ");
          current.printInfo();	//Prozess-Informationen ausgeben
          current.start();	//Prozess starten
        }
        else {			//bereits ein Prozess aktiv
          if(!current.isAlive()) {
	  //aktiver Prozess lebt nicht mehr, ist also fertig
            current.removeProcess();	//Prozess aus Liste entfernen
            current = PriorityProcess.getFirst();
	    //zu aktivierender Prozess = nchster in Liste

            if(current.isSuspended()) {
	    //zu aktivierender Prozess wurde zuvor suspendiert
              System.out.print("Scheduler decided: Restore process: ");
              current.printInfo();	//Prozess-Informationen ausgeben
	      current.unsetSuspended();	//Suspend-Flag entfernen (suspended = false)
	      current.resume();		//Prozess wiederherstellen
	    }
	    else {
	    //zu aktivierender Prozess wurde nicht suspendiert (ist also "neu")
              System.out.print("Scheduler decided: Switch to next process in queue: ");
              current.printInfo();	//Prozess-Informationen ausgeben
	      current.start();		//Prozess starten
	    }
	  }

          if(current != PriorityProcess.getFirst()) {
	  //aktiver Prozess entspricht nicht erstem in Queue
            /////////////////////////////////
            //				   //
            //                             //
	    // Zu ergnzender Programmteil //
	    //                             //
	    //                             //
	    /////////////////////////////////
          }
          else {
	  //aktiver Prozess entspricht auch erstem in Queue, also beibehalten
            System.out.print("Scheduler decided: Keep process ");
	    current.printInfo();	//Prozess-Informationen ausgeben
          }
        }
        Thread.sleep(20);
      }
      catch (Exception e) {
        System.out.println("Nothing more to do.");
        System.exit(0);	//Simulation beenden (alle Prozesse terminiert)
      }
    }
  }
}
