import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class MoveBall extends Applet 
{
  public static final int DIAMETER = 40;
  public static final int AMOUNT = 2;
  public static final Color BALLCOLOR = Color.blue;
  
  BallCanvas bc;
  
  public void init() 
  {
    // Fenster aufbauen. 
    // Fenster besteht aus berschrift, einem Canvas und Knpfen.
    setLayout(new BorderLayout());
    Panel title = new Panel();
    title.setLayout(new FlowLayout(FlowLayout.CENTER));
    title.add(new Label("Moving Ball"));
    add(title, BorderLayout.NORTH);
    
    int x = (getSize().width - DIAMETER) / 2;
    int y = (getSize().height - DIAMETER) / 2;

    bc = new BallCanvas(x, y);
    add(bc, BorderLayout.CENTER);
   
    Panel buttons = new Panel();
    buttons.setLayout(new FlowLayout(FlowLayout.CENTER));

    Button moveLeft = new Button("<-");
    moveLeft.addActionListener(
      new ActionListener() 
      {
	public void actionPerformed(ActionEvent e) 
	  {
	    bc.moveBall(-AMOUNT, 0);
	  }
      });
    buttons.add(moveLeft);
    
    Button moveRight = new Button("->");
    moveRight.addActionListener(
      new ActionListener()
      {
	public void actionPerformed(ActionEvent e)
	  {
	    bc.moveBall(AMOUNT, 0);
	  }
      });
    buttons.add(moveRight);
    add(buttons, BorderLayout.SOUTH);
  }
}

class BallCanvas extends Canvas 
{
  int x, y, diameter;
  
  BallCanvas(int X, int Y) 
  {
    diameter = MoveBall.DIAMETER;
    x = X;
    y = Y;
    setBackground(Color.white);
  }
  
  public void paint(Graphics g)
  {
    g.setColor(MoveBall.BALLCOLOR);
    g.fillOval(x, y, diameter, diameter);
  }
  
  void moveBall(int deltax, int deltay)
  {
    x += deltax;
    y += deltay;
    if (x < 0) x = 0;
    if (y < 0) y = 0;
    Dimension s = getSize();
    if (x > s.width - diameter) x = s.width - diameter;
    if (y > s.height - diameter) y = s.height - diameter;
    
    repaint();
  }
}
