import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class PrimeApplet extends Applet 
{
  TextField numberEntry;
  
  public void init() 
  {
    setLayout (new BorderLayout ()); 

    // berschrift zentriert darber erzeugen.
    add (new Label("Prime Checker", Label.CENTER), BorderLayout.NORTH);

    // Eingabefeld mit Beschriftung im Zentrum erzeugen.
    Panel entry = new Panel();
    entry.setLayout (new FlowLayout (FlowLayout.CENTER));
    
    entry.add (new Label("Enter a Number: "));
    numberEntry = new TextField("", 20);
    entry.add (numberEntry);
    add(entry, BorderLayout.CENTER);
    
    // PrimeCalculator wird ActionListener des Eingabefeldes.
    numberEntry.addActionListener (new PrimeCalculator());
  }

}

// PrimeCalculator ist ebenfalls in dieser Datei deklariert. Das
// geht nur, weil PrimeCalculator nicht public ist. 

class PrimeCalculator implements ActionListener 
{
  public void actionPerformed(ActionEvent e) 
  {
    long number;
    long nextprime;
   
    // Ermittle die Zahl, die der Benutzer eingab.
    String entry = ((TextField)e.getSource()).getText();
    
    try 
      {
	number = Long.parseLong(entry);
      }
    catch (NumberFormatException ex)  
      {
	showResult ("Illegal number!");
	return;
      }
    
    // Wenn's eine Primzahl ist, sag es.
    if (isPrime(number)) {
      showResult (number + " is a prime.");
    }
    else 
    {
      // War keine. Rechne die nchste Primzahl aus.
      nextprime = number + 1;
      if (nextprime % 2 == 0)  // Grade Zahlen testen wir gar nicht erst.
	nextprime++;
      
      while(!isPrime(nextprime)) 
	nextprime += 2;

      showResult (number + " is not a prime.", "Next prime is " + nextprime);
      
    }
  }
  
  boolean isPrime(long number) 
  {
    // Prft, ob number eine Primzahl ist.
    long divisor;
    
    if (number < 0)      // Negativ. Berechne entsprechende Positive Zahl.
      number = -number;
    if (number < 4)      // 1, 2 und 3 sind Primzahlen.
      return true;
    if (number % 2 == 0) // Alle grade Zahlen nicht.
      return false;

    divisor = 3;         // Ungrade Zahlen ab 3 als Teiler ausprobieren.
    
    while (divisor * divisor <= number) {
      if (number % divisor == 0)
	return false;
      divisor = divisor + 2;
    }
    
    return true;
  }
  
  void showResult(String msg) 
  {
    new MessageBox(msg, "");
  }
  void showResult(String msg1, String msg2) 
  {
    new MessageBox(msg1, msg2);
  }
}
  
class MessageBox extends Frame
{

  Button cb;
  
  MessageBox(String msg1, String msg2) 
  {
    super("Prime Calculation");
    
    // Zeige Ergebnis der Primzahlberechnung in 2 Zeilen jeweils zentriert.
    setLayout(new BorderLayout());
    add(new Label(msg1, Label.CENTER), BorderLayout.NORTH);
    add(new Label(msg2, Label.CENTER), BorderLayout.CENTER);
    cb = new Button("Close");
    add(cb, BorderLayout.SOUTH);
    cb.addActionListener(
       new ActionListener() 
       {
	 public void actionPerformed(ActionEvent e) 
	   {
	     dispose();
	   }
       });
    pack();
    setVisible(true);
  }
}
